'Blitzdatenlogger, ES-M32 mit LCD und EEPROM

$regfile = "m32def.dat"
$crystal = 11059200
$hwstack = 16
$swstack = 32
$framesize = 128

Baud = 9600


Dim N As Word
Dim U As Word
Dim D As Word
Dim A As Byte                                               'Adresse
Dim Trigger As Byte
Dim Sta As Byte                                             'Startadresse , Trigerpunkt

Dim Eeadr As Word
Dim Ramadr As Byte
Dim I As Byte
Dim J As Byte
Dim B As Byte
Dim Ticks As Word                                           'Zeitmessung
Dim Ticks2 As Word
Dim Level As Word

Dim Daten(8) As Byte

S1 Alias Pind.2
S2 Alias Pind.3
S3 Alias Pind.6
S4 Alias Pind.7

Config Portd = &B00110000
Portd.2 = 1
Portd.3 = 1
Portd.6 = 1
Portd.7 = 1

Out1 Alias Portd.4
Out2 Alias Portd.5

Config Adc = Single , Prescaler = 8 , Reference = Off
Start Adc

Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2

Initlcd
Cls

Ddrd = 255
Open "com1:" For Binary As #1


Config Timer0 = Counter , Edge = Falling


'Dim D As Word
'Dim B As Byte
'Dim Level As Word
'Dim Eeadr As Word
'Dim N As Byte


'For N = 0 To 50
'  Readeeprom B , N
'  Print #1 , B
'Next N
Ramadr = 1
Timer0 = 0
Do
  B = Timer0
  If B > 0 Then
    Daten(ramadr) = B
    Ramadr = Ramadr + 1
    If Ramadr > 8 Then Ramadr = 1
    If B > 80 Then
      B = 80
      Waitms 300
    End If
    If Eeadr < 1023 Then Writeeeprom B , Eeadr
    Eeadr = Eeadr + 1
    Print #1 , B
    D = B
    D = D * 100
    Level = Level + D
    If Level > 20000 Then Level = 20000
    Timer0 = 0
  End If
  If Level > 10 Then
  Level = Level - 1                                         '1 Blitz in 10 min vergessen
  If Level > 2000 Then Level = Level - 9                    '1 Blitz in 1 min vergessen
  If Level > 6000 Then Level = Level - 20                   '3 Blitze in 1 min vergessen
  End If
  If Level < 1000 Then Portd = &B11001100                   'weniger als 1 Blitz in 10 min
  If Level > 1000 Then Portd = &B11011100                   '>10 Blitze pro min
  If Level > 2000 Then Portd = &B11101100                   '<1 Blitz pro min
  If Level > 6000 Then Portd = &B11111100                   '>3 Blitze pro min
     Locate 2 , 1
     Lcd Level
     Lcd "   "

  For Ticks = 1 To 10
  J = Ischarwaiting(#1)
    If J > 0 Then
      Get #1 , J
      If J = 100 Then
        B = 0
        For N = 0 To 1023
           Writeeeprom B , N
        Next N
      End If
      A = J * 128
      For N = 1 To 128
        Readeeprom B , A
        Put #1 , B
        A = A + 1
      Next N
    End If
    Waitms 100
  Next Ticks

  For N = 0 To 7
    D = N * 2
    D = D + 1
    Locate 1 , D
    A = N + 1
    D = Daten(a)
    Lcd D
  Next N

Loop
End




End